from datetime import datetime, timedelta
from typing import Optional
from fastapi import Depends, HTTPException, status
from fastapi.security import OAuth2PasswordBearer
from jose import JWTError, jwt
from passlib.context import CryptContext
from pydantic import ValidationError
from bson import ObjectId

from .database import get_db
from .models import TokenData, User, UserInDB

# to get a string like this run:
# openssl rand -hex 32
SECRET_KEY = "YOUR_SECRET_KEY_HERE"
ALGORITHM = "HS256"
ACCESS_TOKEN_EXPIRE_MINUTES = 30

pwd_context = CryptContext(schemes=["bcrypt"], deprecated="auto")
oauth2_scheme = OAuth2PasswordBearer(tokenUrl="token")


def verify_password(plain_password, hashed_password):
  return pwd_context.verify(plain_password, hashed_password)


def get_password_hash(password):
  return pwd_context.hash(password)


def get_user(db, username: str) -> Optional[UserInDB]:
  user_dict = db.users.find_one({"username": username})
  if user_dict:
    return UserInDB(**user_dict)


def authenticate_user(db, username: str, password: str) -> Optional[UserInDB]:
  user = get_user(db, username)
  if not user:
    return None
  if not verify_password(password, user.hashed_password):
    return None
  return user


def create_access_token(data: dict, expires_delta: Optional[timedelta] = None):
  to_encode = data.copy()
  if expires_delta:
    expire = datetime.utcnow() + expires_delta
  else:
    expire = datetime.utcnow() + timedelta(minutes=15)
  to_encode.update({"exp": expire})
  encoded_jwt = jwt.encode(to_encode, SECRET_KEY, algorithm=ALGORITHM)
  return encoded_jwt


async def get_current_user(token: str = Depends(oauth2_scheme)):
  credentials_exception = HTTPException(
      status_code=status.HTTP_401_UNAUTHORIZED,
      detail="Could not validate credentials",
      headers={"WWW-Authenticate": "Bearer"},
  )
  try:
    payload = jwt.decode(token, SECRET_KEY, algorithms=[ALGORITHM])
    username: str = payload.get("sub")
    if username is None:
      raise credentials_exception
    token_data = TokenData(username=username)
  except (JWTError, ValidationError):
    raise credentials_exception

  db = get_db()
  user = get_user(db, username=token_data.username)
  if user is None:
    raise credentials_exception
  return user


async def get_current_active_user(current_user: User = Depends(get_current_user)):
  if not current_user.is_active:
    raise HTTPException(status_code=400, detail="Inactive user")
  return current_user


def create_user(db, user: UserInDB):
  user_dict = user.model_dump(exclude={"id"})
  user_dict["_id"] = ObjectId()
  result = db.users.insert_one(user_dict)
  new_user = db.users.find_one({"_id": result.inserted_id})
  return UserInDB(**new_user)
